<?php
require_once(dirname(__FILE__).'/../../upgrade.php');
class drop_attachments_table extends UPGRADE
{
	/**
	* IsAlreadyUpgraded
	* Do we need to run this classes upgrade script or not ?
	*
	* @return bool true if the upgrade has already run, otherwise false
	*/
	function IsAlreadyUpgraded()
	{
		return !$this->TableExists($GLOBALS['tablePrefix'].'attachments');
	}

	/**
	* Upgrade
	* Do the actual upgrade of this component. If this is successful all
	* subsequent calls to IsAlreadyUpgraded should return true
	*
	* @return void
	*/
	function Upgrade()
	{
		$query = '
			DROP TABLE '.$GLOBALS['tablePrefix'].'attachments
		';
		$result = $GLOBALS['AKB_DB']->Query($query);
	}

}
?>
