<?php
require_once(dirname(__FILE__).'/../../upgrade.php');
class create_members_table extends UPGRADE
{
	/**
	* IsAlreadyUpgraded
	* Do we need to run this classes upgrade script or not ?
	*
	* @return bool true if the upgrade has already run, otherwise false
	*/
	function IsAlreadyUpgraded()
	{
		return $this->TableExists($GLOBALS['tablePrefix'].'members');
	}

	/**
	* Upgrade
	* Do the actual upgrade of this component. If this is successful all
	* subsequent calls to IsAlreadyUpgraded should return true
	*
	* @return void
	*/
	function Upgrade()
	{
		$query = '
			CREATE TABLE `'.$GLOBALS['tablePrefix'].'members` (
				`userid` int not null default 0,
				`groupid` int not null default 0,
				PRIMARY KEY (`userid`, `groupid`)
			)
		';
		$result = $GLOBALS['AKB_DB']->Query($query);
	}

}
?>
