<?php
require_once(dirname(__FILE__).'/../../upgrade.php');
class create_questions_customfields_table extends UPGRADE
{
	/**
	* IsAlreadyUpgraded
	* Do we need to run this classes upgrade script or not ?
	*
	* @return bool true if the upgrade has already run, otherwise false
	*/
	function IsAlreadyUpgraded()
	{
		return $this->TableExists($GLOBALS['tablePrefix'].'questions_customfields');
	}

	/**
	* Upgrade
	* Do the actual upgrade of this component. If this is successful all
	* subsequent calls to IsAlreadyUpgraded should return true
	*
	* @return void
	*/
	function Upgrade()
	{
		$query = "
			CREATE TABLE `".$GLOBALS['tablePrefix']."questions_customfields` (
			  `questions_customfieldsid` int(11) NOT NULL auto_increment,
			  `questionid` int(11) NOT NULL,
			  `customfieldid` int(11) NOT NULL,
			  `data` varchar(250) NOT NULL,
			  PRIMARY KEY  (`questions_customfieldsid`),
			  KEY `questionid` (`questionid`),
			  KEY `customfieldid` (`customfieldid`)
			)			
		";			

		$result = $GLOBALS['AKB_DB']->Query($query);
	}
}
?>
