<?php
require_once(dirname(__FILE__).'/../../upgrade.php');
class create_column_sessionid extends UPGRADE
{
	/**
	* IsAlreadyUpgraded
	* Do we need to run this classes upgrade script or not ?
	*
	* @return bool true if the upgrade has already run, otherwise false
	*/
	function IsAlreadyUpgraded()
	{
		return $this->ColumnExists($GLOBALS['tablePrefix'].'users', 'sessionid');
	}

	/**
	* Upgrade
	* Do the actual upgrade of this component. If this is successful all
	* subsequent calls to IsAlreadyUpgraded should return true
	*
	* @return void
	*/
	function Upgrade()
	{
		$query = "ALTER TABLE `".$GLOBALS['tablePrefix']."users` ADD COLUMN `sessionid` varchar(32) NOT NULL default ''";
		$result = $GLOBALS['AKB_DB']->Query($query);
	}
}
?>
