<?php
require_once(dirname(__FILE__).'/../../upgrade.php');
class create_idx_a_pk extends UPGRADE
{
	/**
	* IsAlreadyUpgraded
	* Do we need to run this classes upgrade script or not ?
	*
	* @return bool true if the upgrade has already run, otherwise false
	*/
	function IsAlreadyUpgraded()
	{
		$table = $GLOBALS['tablePrefix'].'categoryassociations';

		$columns = array(
			'categoryid',
			'questionid',
		);

		$unique = true;

		$type = 'BTREE';

		return $this->IndexExists($table, $columns, $unique, $type);
	}

	/**
	* Upgrade
	* Do the actual upgrade of this component. If this is successful all
	* subsequent calls to IsAlreadyUpgraded should return true
	*
	* @return void
	*/
	function Upgrade()
	{
		$query = '
			ALTER IGNORE TABLE `'.$GLOBALS['tablePrefix'].'categoryassociations`
			ADD UNIQUE INDEX `idx_a_pk` (`categoryid`,`questionid`)
		';
		$result = $GLOBALS['AKB_DB']->Query($query);
	}

}
?>
