<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11">
<html>
<head>
	<title>%%LNG_InstallInterspireKnowledgeManager%%</title>
	<meta http-equiv="Content-Type" content="text/html; charset=%%GLOBAL_CharacterSet%%" />
	<meta name="robots" content="noindex, nofollow" />
	<style type="text/css">
		@import url("styles/styles.css");
		@import url('styles/tabmenu.css');
		@import url("styles/iselector.css");
	</style>
	<!--[if IE]>
	<style type="text/css">
		@import url("styles/ie.css");
	</style>
	<![endif]-->
	<style>
		h3 { font-size:13px; }
	</style>
	<link rel="stylesheet" href="styles/thickbox.css" type="text/css" media="screen" />
	<script type="text/javascript" language="javascript">
		var url = 'remote.php';
		var critical_errors = "%%GLOBAL_CriticalErrors%%";
		var is_trial = '%%GLOBAL_IsTrial%%';
		
	function ShowHelp(img, title, desc)
	{
		div = document.createElement('div');
		div.id = 'help';
		div.style.display = 'inline';
		div.style.position = 'absolute';
		div.style.width = '190px';
		div.style.backgroundColor = '#FEFCD5';
		div.style.border = 'solid 1px #E7E3BE';
		div.style.padding = '10px';
		div.innerHTML = '<span class="helpTip"><strong>' + title + '<\/strong><\/span><br /><img src=images/1x1.gif width="1" height="5"><br /><div style="padding-left:10; padding-right:5" class="helpTip">' + desc + '<\/div>';
		img.parentNode.appendChild(div);
	}

	function HideHelp(img)
	{
		div = document.getElementById('help');
		if (div) {
			img.parentNode.removeChild(div);
		}
	}
		
	var NoLicenseKey = "%%LNG_NoLicenseKey%%";
	var InstallMissingKnowledgebaseName = "%%LNG_InstallMissingKnowledgebaseName%%";
	var InstallMissingPathToKB = "%%LNG_InstallMissingPathToKB%%";
	var InstallMissingUsername = "%%LNG_InstallMissingUsername%%";
	var InstallMissingPassword = "%%LNG_InstallMissingPassword%%";
	var InstallPasswordMismatch = "%%LNG_InstallPasswordMismatch%%";
	var InstallMissingEmail = "%%LNG_InstallMissingEmail%%";
	var InstallInvalidEmail = "%%LNG_InstallInvalidEmail%%";
	var InstallMissingFirstname = "%%LNG_InstallMissingFirstname%%";
	var InstallMissingLastname = "%%LNG_InstallMissingLastname%%";
	var InstallMissingCountryLocation = "%%LNG_InstallMissingCountryLocation%%";
	var InstallMissingPhoneNumber = "%%LNG_InstallMissingPhoneNumber%%";
	var InstallMissingDbType = "%%LNG_InstallMissingDbType%%";
	var InstallTFExceedLength = "%%LNG_InstallTFExceedLength%%";
	var InstallMissingDbServer = "%%LNG_InstallMissingDbServer%%";
	var InstallMissingDbUser = "%%LNG_InstallMissingDbUser%%";
	var InstallMissingDbPass = "%%LNG_InstallMissingDbPass%%";
	var InstallMissingDbDatabase = "%%LNG_InstallMissingDbDatabase%%";
	
	</script>
	<script type="text/javascript" src="../javascript/jquery.js"></script>
	<script type="text/javascript" src="../javascript/menudrop.js"></script>
	<script type="text/javascript" src="../javascript/thickbox.js"></script>
	<script type="text/javascript" src="../javascript/install.js"></script>
	<script type="text/javascript" src="../javascript/iselector.js"></script>
	<script type="text/javascript" src="../javascript/common.js"></script>
</head>

<body style="background-image:url(images/gradient.jpg);">
	<form action="index.php?ToDo=RunInstallation" method="post" name="frmInstall" id="frmInstall">
	<div id="box">
		<br /><br /><br /><br />
		<table><tr><td style="border:solid 2px #DDD; padding:20px; background-color:#FFF; width:450px">
		<table>
		  <tr>
			<td class="Heading1">
				<img src="images/logo.jpg" />
			</td>
		  </tr>
		  <tr>
			<td class="HelpInfo">
				%%GLOBAL_Message%%
			</td>
		  </tr>
		  <tr class="FormContent">
			<td>
				<table>
					<tr style="%%GLOBAL_HideLicenseKey%%;">
						<td nowrap style="padding:10px 10px 10px 0px" colspan="2"><h3 style="padding-bottom:0px;margin:0px;">%%LNG_LicenseDetails%%</h3></td>
					</tr>
					<tr style="%%GLOBAL_HideLicenseKey%%;">
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_LicenseKey%%:</td>
						<td>
							<input type="text" name="licenseKey" id="licenseKey" class="Field250" value="%%GLOBAL_LicenseKey%%" > 
							<img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_LicenseKey%%', '%%LNG_LicenseKeyHelp%%');" src="images/help.gif" width="24" height="16" border="0">
							<div style="display:none" id="keyhelp"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:10px 10px 10px 0px" colspan="2"><h3 style='padding-bottom:0px;margin:0px;'>%%LNG_KnowledgeManagerDetails%%</h3></td>
					</tr>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_KnowledgebaseName%%:</td>
						<td><input type="text" name="knowledgebaseName" id="knowledgebaseName" class="Field250" value="%%GLOBAL_knowledgebaseName%%"> <img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_KnowledgebaseName%%', '%%LNG_KnowledgebaseNameHelp%%')" src="images/help.gif" width="24" height="16" border="0">
						<div style="display:none" id="knowledgebasenamehelp"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_PathToKB%%:</td>
						<td><input type="text" name="pathToKB" id="pathToKB" class="Field250" value="%%GLOBAL_pathToKB%%"> <img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_PathToKB%%', '%%LNG_PathToKBHelp%%')" src="images/help.gif" width="24" height="16" border="0">
						<div style="display:none" id="pathtokbhelp"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:10px 10px 10px 0px" colspan="2"><h3 style='padding-bottom:0px;margin:0px;'>%%LNG_UserAccountDetails%%</h3></td>
					</tr>

					<tr>
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_Username%%:</td>
						<td>
							<input type="text" autocomplete="off" name="username" id="username" class="Field250" value="%%GLOBAL_username%%">
							<img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_Username%%', '%%LNG_UsernameHelp%%')" src="images/help.gif" width="24" height="16" border="0">
						<div style="display:none" id="usernamehelp"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> Password:
						</td>
						<td>
							<input type="password" autocomplete="off" name="password" id="password" class="Field250" value="">
							<img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_Password%%', '%%LNG_PasswordHelp%%')" src="images/help.gif" width="24" height="16" border="0">
							<div style="display:none" id="passwordhelp"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> Password (confirm):
						</td>
						<td>
							<input type="password" autocomplete="off" name="password1" id="password1" class="Field250" value="">
							<img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_Password1%%', '%%LNG_Password1Help%%')" src="images/help.gif" width="24" height="16" border="0">
							<div style="display:none" id="password1help"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> Email:
						</td>
						<td>
							<input type="text" name="email" id="email" class="Field250" value="%%GLOBAL_email%%">
							<img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_Email%%', '%%LNG_EmailHelp%%')" src="images/help.gif" width="24" height="16" border="0">
							<div style="display:none" id="emailhelp"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> First Name:
						</td>
						<td>
							<input type="text" name="firstname" id="firstname" class="Field250" value="%%GLOBAL_firstname%%">
							<img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_Firstname%%', '%%LNG_FirstnameHelp%%')" src="images/help.gif" width="24" height="16" border="0">
							<div style="display:none" id="firstnamehelp"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> Last Name:
						</td>
						<td>
							<input type="text" name="lastname" id="lastname" class="Field250" value="%%GLOBAL_lastname%%">
							<img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_Lastname%%', '%%LNG_LastnameHelp%%')" src="images/help.gif" width="24" height="16" border="0">
							<div style="display:none" id="lastnamehelp"></div></td>
					</tr>
					<tr style="%%GLOBAL_HidePhoneNumber%%;">
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_PhoneNumber%%:
						<td>
							<input type="text" name="phoneNumber" id="phoneNumber" class="Field250" value="%%GLOBAL_PhoneNumber%%">
							<img onmouseout="HideHelp(this);" onmouseover="ShowHelp(this, '%%LNG_PhoneNumber%%', '%%LNG_PhoneNumberHelp%%')" src="images/help.gif" width="24" height="16" border="0">
							<div style="display:none" id="phonenumberhelp"></div></td>
					</tr>
					<tr style="%%GLOBAL_HideCountryLocation%%;">
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_CountryLocation%%:
						<td>
							<select name="countryLocation" id="countryLocation" class="Field250">
								<option value="0">-- %%LNG_ChooseACountry%% --</option>
								%%GLOBAL_CountryList%%
							</select><img onmouseout="HideHelp(this);" onmouseover="ShowHelp(this, '%%LNG_CountryLocation%%', '%%LNG_CountryLocationHelp%%')" src="images/help.gif" width="24" height="16" border="0">
							<div style="display:none" id="countrylocationhelp"></div></td>
					</tr>
					<tr>
						<td nowrap style="padding:10px 10px 10px 0px" colspan="2"><h3 style='padding-bottom:0px;margin:0px;'>%%LNG_MySQLDetails%%</h3></td>
					</tr>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px" colspan="2"><input type="radio" name="dbChoice" id="dbChoice1" value="ON"> <label for="dbChoice1">%%LNG_HasDB%%</label></td>
					</tr>
				</table>
				<table class="DBDetails" style="padding:10px 10px 10px 20px">
					<tr class="DBDetails">
						<td nowrap style="padding:0px 10px 0px 10px" valign="top"><span class="Required">*</span> %%LNG_DatabaseType%%:</td>
						<td>
						<select name="databaseType" id="databaseType" class="Field150">
							<option value="mysql" %%GLOBAL_useMySql%%>%%LNG_UseMySQL%%</option>
							<option value="mssql" %%GLOBAL_useMsSql%%>%%LNG_UseMsSQL%%</option>
							<option value="oci8" %%GLOBAL_useOci8%%>%%LNG_UseOci8%%</option>
						</select>
						<div style="display:none" id="databasetypehelp"></div></td>
					</tr>
					<tr class="DBDetails">
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_DatabaseUser%%:</td>
						<td><input type="text" name="mySQLUser" id="mySQLUser" class="Field150" value="%%GLOBAL_mySQLUser%%"> <img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_DatabaseUser%%', '%%LNG_DatabaseUserHelp%%')" src="images/help.gif" width="24" height="16" border="0">
						<div style="display:none" id="mysqluserhelp"></div></td>
					</tr>
					<tr class="DBDetails">
						<td nowrap style="padding:0px 10px 0px 10px">&nbsp;&nbsp; %%LNG_DatabasePassword%%:</td>
						<td><input type="password" name="mySQLPass" id="mySQLPass" class="Field150" value="%%GLOBAL_dbPass%%"> <img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_DatabasePassword%%', '%%LNG_DatabasePasswordHelp%%')" src="images/help.gif" width="24" height="16" border="0">
						<div style="display:none" id="mysqlpasshelp"></div></td>
					</tr>
					<tr class="DBDetails">
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_DatabaseHostname%%:</td>
						<td><input type="text" name="mySQLServer" id="mySQLServer" class="Field150" value="%%GLOBAL_mySQLServer%%"> <img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_DatabaseHostname%%', '%%LNG_DatabaseHostnameHelp%%')" src="images/help.gif" width="24" height="16" border="0"><div style="display:none" id="mysqlserverhelp"></div></td>
					</tr>
					<tr class="DBDetails">
						<td nowrap style="padding:0px 10px 0px 10px"><span class="Required">*</span> %%LNG_DatabaseName%%:</td>
						<td><input type="text" name="mySQLDatabase" id="mySQLDatabase" class="Field150" value="%%GLOBAL_mySQLDatabase%%"> <img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_DatabaseName%%', '%%LNG_DatabaseNameHelp%%')" src="images/help.gif" width="24" height="16" border="0"><div style="display:none" id="mysqldatabasehelp"></div></td>
					</tr>
					<tr class="DBDetails">
						<td nowrap style="padding:0px 10px 0px 10px">&nbsp;&nbsp; %%LNG_DatabaseTablePrefix%%:</td>
						<td><input type="text" name="tablePrefix" id="tablePrefix" class="Field150" value="%%GLOBAL_tablePrefix%%"> <img onMouseOut="HideHelp(this);" onMouseOver="ShowHelp(this, '%%LNG_DatabaseTablePrefix%%', '%%LNG_DatabaseTablePrefixHelp%%')" src="images/help.gif" width="24" height="16" border="0"><div style="display:none" id="dbprefixhelp"></div></td>
					</tr>
				</table>
				<table>
					<tr>
						<td nowrap style="padding:0px 10px 0px 10px" colspan="2" ><input type="radio" name="dbChoice" id="dbChoice2" value="ON"> <label for="dbChoice2">%%LNG_HasNoDB%%</label></td>
					</tr>
				</table>
				<table class="DBHelp" style="padding:10px 10px 10px 20px">
					<tr class="DBHelp">
						<td colspan="2" class="HelpInfo" style="padding-top:0px;"><h3 style="padding-bottom:10px">%%LNG_WhatIsMySQLDB%%</h3>%%LNG_DBHelpText%%</td>
					</tr>
				</table>
				<table>
					<tr>
						<td nowrap style="padding:10px 10px 10px 0px" colspan="2"><h3 style='padding-bottom:0px;margin:0px;'>%%LNG_ServerConfigurationDetails%%</h3></td>
					</tr>
					<tr>
						<td>
							<input type="hidden" name="sendStats" value="false" />
							<input type="checkbox" name="sendStats" value="true" id="sstats" checked="checked" /><label for="sstats">%%LNG_SendAnonStats%%</label>
							<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="alert('%%LNG_ServerDetailsInfo%%')" style="color:gray">%%LNG_WhatWillBeSent%%</a></td>
						</td>
					</tr>

					<tr>

						<td>
							<br /><input type="submit" name="SubmitButton" value="%%LNG_Continue%%" class="FormButton">
						</td>
					</tr>
					<tr>
						<td class="Gap"></td>
					</tr>
				</table>
			</td>
		  </tr>
		</table>

		</td>
		</tr>
		</table>
			<div style="padding:10px; margin-bottom:20px; text-align:center" class="PageFoot">
			<!-- Removing this "Powered by" link will violate your license agreement with Interspire -->
			%%LNG_PagePoweredByShort%%
		</div>	</div>
	</form>

	<div id="permissionsBox" style="display:none">
		<div style="background-image:url('images/permissions_error.gif'); background-position:right bottom; background-repeat:no-repeat; height:100%">%%GLOBAL_PermissionErrors%%</div>
	</div>

	<script defer>%%GLOBAL_AutoJS%%</script>

</body>
</html>