<?php
require_once(dirname(__FILE__).'/../../upgrade.php');
class create_groups_table extends UPGRADE
{
	/**
	* IsAlreadyUpgraded
	* Do we need to run this classes upgrade script or not ?
	*
	* @return bool true if the upgrade has already run, otherwise false
	*/
	function IsAlreadyUpgraded()
	{
		return $this->TableExists($GLOBALS['tablePrefix'].'groups');
	}

	/**
	* Upgrade
	* Do the actual upgrade of this component. If this is successful all
	* subsequent calls to IsAlreadyUpgraded should return true
	*
	* @return void
	*/
	function Upgrade()
	{
		$query = '
			CREATE TABLE `'.$GLOBALS['tablePrefix'].'groups` (
				`groupid` int not null auto_increment ,
				`name` varchar(50) not null,
				`permissions` text not null,
				`application` text not null,
				`contactable` tinyint(1) not null default 0,
				PRIMARY KEY (`groupid`),
				unique name (`name`)
			)
		';
		$result = $GLOBALS['AKB_DB']->Query($query);
	}

}
?>
