<?php
require_once(dirname(__FILE__).'/../../upgrade.php');
class create_idx_q_ft extends UPGRADE
{
	/**
	* IsAlreadyUpgraded
	* Do we need to run this classes upgrade script or not ?
	*
	* @return bool true if the upgrade has already run, otherwise false
	*/
	function IsAlreadyUpgraded()
	{
		$table = $GLOBALS['tablePrefix'].'questions';

		$columns = array(
			'title',
			'answer',
			'metakeywords',
		);

		$unique = false;

		$type = 'FULLTEXT';

		return $this->IndexExists($table, $columns, $unique, $type);
	}

	/**
	* Upgrade
	* Do the actual upgrade of this component. If this is successful all
	* subsequent calls to IsAlreadyUpgraded should return true
	*
	* @return void
	*/
	function Upgrade()
	{
		$query = '
			CREATE FULLTEXT INDEX `idx_q_ft`
			ON `'.$GLOBALS['tablePrefix'].'questions`(`title`, `answer`, `metakeywords`)
		';
		$result = $GLOBALS['AKB_DB']->Query($query);
	}

}
?>
